<script setup lang="ts">
import { computed, ref, watch } from 'vue'

import ProductList from '@/Pos/components/ProductList.vue'
import ReceiptItemList from '@/Pos/components/ReceiptItemList.vue'
import MemberSearch from '@/Pos/components/MemberSearch.vue'
import CustomerDialog from '@/Customer/components/CustomerDialog.vue'
import { useAuthStore } from '@/views/Auth/stores/auth'
import MemberCard from '../components/MemberCard.vue'
import { type ReceiptItem } from '@/Pos/types/ReceiptItem'
import { type Product } from '@/Product/types/Product'
import type { Receipt } from '@/Pos/types/Receipt'
import ReceiptPaper from './ReceiptPaper.vue'
import { onMounted } from 'vue'
import type { Member } from '@/Pos/types/Member'
import { useReceiptStore } from '@/Pos/stores/receipt'
import { usePosStore } from '@/Pos/stores/pos'
import { useCustomerStore } from '@/Customer/stores/customer'
import ReceiptDialog from '../components/ReceiptDialog.vue'
const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const posStore = usePosStore()
const customerStore = useCustomerStore()
const snackbar = ref(false)
const showMemberBox = ref(false)
const log = ref('')
const product = ref<Product>()
const receiptItemList = ref<typeof ReceiptItemList | null>(null)
const dialogReceipt = ref(false)
function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    productId: p.id
  }
  receiptStore.addReceiptItem(newReceiptItem)
  snackbar.value = true
}

const currentUser = authStore.getCurrentUser()

// const refreshReceiptItems = () => {
//   receiptStore.receiptItems.value = [...receiptItems.value]
// }

const tab = ref(null)
onMounted(async () => {
  await posStore.getProducts()
})

function selectedMember(member: Member) {}
</script>

<template>
  <v-container>
    <v-row>
      <v-col>{{ log }}</v-col>
    </v-row>
    <v-row>
      <v-col cols="12" md="6">
        <v-sheet max-width="600" min-width="300" height="720" elevation="3" class="overflow-auto">
          <!-- header -->
          <v-img
            height="100"
            src="https://i.pinimg.com/564x/22/49/84/224984972b3a833cb764dd7bdc512054.jpg"
            style="opacity: 1"
            cover
          >
            <v-container>
              <v-row>
                <v-col>
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: rgb(255, 255, 255);
                      font-size: 35px;
                    "
                  >
                    Point of Sale
                  </h1>
                </v-col>
                <v-col></v-col>
              </v-row>
            </v-container>
          </v-img>

          <v-tabs v-model="tab" color="orange" align-tabs="start" class="ma-5">
            <v-tab :value="1"><v-icon icon="mdi-coffee"></v-icon>Drink</v-tab>
            <v-tab :value="2"><v-icon icon="mdi-cake-variant"></v-icon>Bakery</v-tab>
            <v-tab :value="3"><v-icon icon="mdi-silverware-fork-knife"></v-icon>Food</v-tab>
          </v-tabs>

          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="posStore.products1" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="posStore.products2" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="posStore.products3" @selected="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <!-- Right Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="auto" elevation="0" rounded style="background-color: rgba(0, 0, 0, 0.8)">
          <v-row no-gutters>
            <v-col cols="12">
              <v-sheet elevation="0" rounded style="background-color: rgba(131, 131, 131, 0.466)">
                <v-img
                  height="80"
                  src="https://i.pinimg.com/564x/78/e3/7d/78e37d57fd461ee7fd594e1efe2715ce.jpg"
                  style="opacity: 1"
                  cover
                >
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: #3e2723;
                      padding-left: 35px;
                      margin: 5px;
                      font-size: 38px;
                    "
                  >
                    Order List
                  </h1>
                </v-img>
                <ReceiptItemList
                  v-model="receiptStore.receiptItems"
                  :editable="true"
                ></ReceiptItemList>
              </v-sheet>
            </v-col>
            <!-- MemberCard and PointCard -->
            <v-col cols="12" style="color: white">
              <h3 style="cursor: pointer" class="pl-5" @click="showMemberBox = !showMemberBox">
                Member Action<v-icon
                  :icon="showMemberBox ? 'mdi-chevron-up' : 'mdi-chevron-down'"
                ></v-icon>
              </h3>
              <v-expand-transition>
                <div v-show="showMemberBox">
                  <v-row no-gutters>
                    <v-col cols="6">
                      <v-sheet
                        width="auto"
                        height="150"
                        elevation="0"
                        style="background-color: #fef1dea4; color: black"
                      >
                        <MemberCard />
                      </v-sheet>
                    </v-col>
                    <v-col cols="6">
                      <v-sheet
                        width="auto"
                        height="150"
                        elevation="0"
                        style="background-color: #fef1dea4; color: black"
                      >
                        <PointCard></PointCard>
                      </v-sheet>
                    </v-col>
                  </v-row>
                </div>
              </v-expand-transition>
            </v-col>
            <!-- Member search old -->
            <!-- <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="80" elevation="3">
                <MemberSearch @selected="selectedMember"></MemberSearch>
              </v-sheet>
            </v-col> -->
            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: #3e2723b0; color: white"
              >
                <v-container style="text-align: center">
                  <v-row>
                    <v-col class="text-h5" cols="12"
                      >รวมเงิน : {{ receiptStore.receipt.total }} บาท</v-col
                    >
                    <v-col class="text-h5" cols="12"
                      >รวม : {{ receiptStore.receipt.amount }} ชิ้น</v-col
                    >
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: #3e2723b0; color: white"
              >
                <PaymentCard />
              </v-sheet>
            </v-col>
          </v-row>
          <!-- Buttons and Actions -->
          <v-container>
            <v-row>
              <v-col cols="6">
                <v-btn
                  block
                  rounded="l"
                  color="#a16942"
                  size="large"
                  @click="customerStore.openDialog()"
                >
                  <v-icon start icon="mdi-wallet-membership"></v-icon>Register Member
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn
                  block
                  rounded="l"
                  color="red-lighten-1"
                  size="large"
                  @click="
                    () => {
                      receiptStore.clear()
                    }
                  "
                >
                  <v-icon start icon="mdi-close"></v-icon>Cancel
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn block rounded="l" color="#693a18" size="large" @click="">
                  <v-icon start icon="mdi-star"></v-icon>Promotion
                </v-btn>
              </v-col>

              <v-col cols="6">
                <v-btn
                  block
                  rounded="l"
                  color="green-darken-2"
                  size="large"
                  @click="dialogReceipt = true"
                >
                  <v-icon start icon="mdi-currency-usd"></v-icon>Payment
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-sheet>
      </v-col>
    </v-row>
  </v-container>
  <!-- <ReceiptPaper
    v-model:modelValue="dialogReceipt"
    :receipt="receiptStore.receipt"
    :receiptItems="receiptStore.receiptItems"
    @agree="
      () => {
        receiptStore.order()
      }
    "
  ></ReceiptPaper> -->
  <ReceiptDialog
    v-model:modelValue="dialogReceipt"
    :receipt="receiptStore.receipt"
    :receiptItems="receiptStore.receiptItems"
    @agree="
      () => {
        receiptStore.order()
      }
    "
  ></ReceiptDialog>
  <!-- <v-snackbar v-model="snackbar">
    {{ product }}

    <template v-slot:actions>
      <v-btn color="pink" variant="text" @click="snackbar = false"> Close </v-btn>
    </template>
  </v-snackbar> -->
  <CustomerDialog></CustomerDialog>
</template>
